#define version		1.0								//simulator version

/*
---------------------------------------------------
ep[^ݒpwb_
Sep[^Ȃǂ͂̃wb_t@CŕύX
ύX͔Ô߃rh邱ƁI
---------------------------------------------------
*/

const double	s_time		=	0.0005;							//sampling time of runge-kutta method[s]
const int		sim_time	=	10;									//simulation time[s]

const int		wide		=	16;									//`̂̉GbW
const int		height		=	6;									//`̂̏cGbW
const double	tri_wide	=	0.005;								//Op`vf̉[m]
const double	tri_height	=	0.005;								//Op`vf̏c[m]

//̂̕	Fwide*tri_wide
//̂̍Fheight*tri_height

const int		node_Num	=	(wide+1)*(height+1);				//`̂̊iq_̐
const int		tri_Num		=	wide*height*2;						//Op`vf̐
const int		area		=	wide*height;						//`̂̕~
const int		f_Num		=	6*area;								//Op`vf̒_̐̑a
const int		NumVars		=	8*node_Num+2*(wide+1);				//VXeϐ̐

//const int k = (wide+1)*height;

const double	get_time	=	0.1;								//f[^擾ԊԊu(fprintfp)[s]
const double	exf_time	=	10.0;								//O͈Ԃ̒[s]
const double	mbf_time	=	5.0;								//ψʂ鎞Ԃ̒[s]
const double	keep_time	=	6.0;								//ψʌ̕ێԂ̒[s]
const double	move_y		=	0.010;								//ψʗ(Dɓꍇ͕̒lƂ)[mm]

const double	h			=	0.080;								//2̂̌[m]

const double	Nela		=	0.45;								//Poisson's ratio
const double	Nvis		=	0.45;
const double	Ntvis		=	0.35;
const double	E			=	50000;								//Young's modulous(vpm:90.0,vem:90.0 ,tem:30.0 Cela:10.0) 
const double	C			=	30;									//Viscous modulous(vpm:50.0,vem:200.0,tem:200.0)
const double	Ct			=	3000;								//three-element Viscous modulous(tem:500) 

const double	Lela		=	(Nela*E)/((1+Nela)*(1-2*Nela));		//Lame's constant(elasticity)
const double	Mela		=	E/(2*(1+Nela));						//Lame's constant(elasticity)
const double	Lvis		=	(Nvis*C)/((1+Nvis)*(1-2*Nvis));		//Lame's constant(viscosity)
const double	Mvis		=	C/(2*(1+Nvis));						//Lame's constant(viscosity)
const double	Ltvis		=	(Ntvis*Ct)/((1+Ntvis)*(1-2*Ntvis));	//Lame's constant(three-element viscosity)
const double	Mtvis		=	Ct/(2*(1+Ntvis));					//Lame's constant(three-element viscosity)

const double	omega		=	2000.0;								//coefficient for CSM
const double	MASS		=	0.19;								//mass of object(̂̎)[kg]

//density@/(c~~)
const double	D			=	(MASS)/(wide*tri_wide*height*tri_height*h);	

//For Runge-Kutta-Fehlberg Method
#define SafetyRatio	0.8
#define Allowance	1e-1//1e-6			

//x/̐(ʐ)
//ʐςareaɐݒ
//_node_Num


