#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <windows.h>
#include <time.h>
#include "RK.h"
#include "data.h"
#include "func.h"
#include "structdata.h"

double triangleArea(int i,struct geo_data *geo);

//Op`vfʐϋϊ֐
double triangleArea(int i,struct geo_data *geo)
{
	double xi,xj,xk,yi,yj,yk;
	double s;
	xi	= geo->point[geo->triangle[i].point_i].x;
	xj	= geo->point[geo->triangle[i].point_j].x;
	xk	= geo->point[geo->triangle[i].point_k].x;
	yi	= geo->point[geo->triangle[i].point_i].y;
	yj	= geo->point[geo->triangle[i].point_j].y;
	yk	= geo->point[geo->triangle[i].point_k].y;

	s	= sqrt(((xk-xi)*(yj-yi)-(xj-xi)*(yk-yi))*((xk-xi)*(yj-yi)-(xj-xi)*(yk-yi)))/2.0;
	return s;
}

void make_MatandArea(FILE *fg, struct geo_data *geo)
{
	temp temp[tri_Num];
	int i,j,k;
	//Op`vf̖ʐς߂
	for(i=0;i<tri_Num;i++)
	{
		geo->triangle[i].area = triangleArea(i,geo);
		//mFp
//		fprintf(fg,"%d\t%lf\n",i,geo->triangle[i].area);
		//܂
	}
	//܂
	
	//ڑs񐶐
	double matx[3][tri_Num];
	double maty[3][tri_Num];

	for(i=0;i<tri_Num;i++)
	{
		int ti,tj,tk;
		ti = geo->triangle[i].point_i;
		tj = geo->triangle[i].point_j;
		tk = geo->triangle[i].point_k;

		matx[0][i] = geo->point[tj].x-geo->point[tk].x;
		maty[0][i] = geo->point[tj].y-geo->point[tk].y;

		matx[1][i] = geo->point[tk].x-geo->point[ti].x;
		maty[1][i] = geo->point[tk].y-geo->point[ti].y;

		matx[2][i] = geo->point[ti].x-geo->point[tj].x;
		maty[2][i] = geo->point[ti].y-geo->point[tj].y;
	}

	for(i=0;i<tri_Num;i++)
	{
		temp[i].matrix[0].mat[0][0]	=	(maty[0][i])*(maty[0][i]);
		temp[i].matrix[0].mat[0][1]	=	-(maty[0][i])*(matx[0][i]);
		temp[i].matrix[0].mat[1][0]	=	-(matx[0][i])*(maty[0][i]);
		temp[i].matrix[0].mat[1][1]	=	(matx[0][i])*(matx[0][i]);

		temp[i].matrix[1].mat[0][0]	=	(maty[0][i])*(maty[1][i]);
		temp[i].matrix[1].mat[0][1]	=	-(maty[0][i])*(matx[1][i]);
		temp[i].matrix[1].mat[1][0]	=	-(matx[0][i])*(maty[1][i]);
		temp[i].matrix[1].mat[1][1]	=	(matx[0][i])*(matx[1][i]);

		temp[i].matrix[2].mat[0][0]	=	(maty[0][i])*(maty[2][i]);
		temp[i].matrix[2].mat[0][1]	=	-(maty[0][i])*(matx[2][i]);
		temp[i].matrix[2].mat[1][0]	=	-(matx[0][i])*(maty[2][i]);
		temp[i].matrix[2].mat[1][1]	=	(matx[0][i])*(matx[2][i]);

		temp[i].matrix[3].mat[0][0]	=	(maty[1][i])*(maty[0][i]);
		temp[i].matrix[3].mat[0][1]	=	-(maty[1][i])*(matx[0][i]);
		temp[i].matrix[3].mat[1][0]	=	-(matx[1][i])*(maty[0][i]);
		temp[i].matrix[3].mat[1][1]	=	(matx[1][i])*(matx[0][i]);

		temp[i].matrix[4].mat[0][0]	=	(maty[1][i])*(maty[1][i]);
		temp[i].matrix[4].mat[0][1]	=	-(maty[1][i])*(matx[1][i]);
		temp[i].matrix[4].mat[1][0]	=	-(matx[1][i])*(maty[1][i]);
		temp[i].matrix[4].mat[1][1]	=	(matx[1][i])*(matx[1][i]);

		temp[i].matrix[5].mat[0][0]	=	(maty[1][i])*(maty[2][i]);
		temp[i].matrix[5].mat[0][1]	=	-(maty[1][i])*(matx[2][i]);
		temp[i].matrix[5].mat[1][0]	=	-(matx[1][i])*(maty[2][i]);
		temp[i].matrix[5].mat[1][1]	=	(matx[1][i])*(matx[2][i]);

		temp[i].matrix[6].mat[0][0]	=	(maty[2][i])*(maty[0][i]);
		temp[i].matrix[6].mat[0][1]	=	-(maty[2][i])*(matx[0][i]);
		temp[i].matrix[6].mat[1][0]	=	-(matx[2][i])*(maty[0][i]);
		temp[i].matrix[6].mat[1][1]	=	(matx[2][i])*(matx[0][i]);

		temp[i].matrix[7].mat[0][0]	=	(maty[2][i])*(maty[1][i]);
		temp[i].matrix[7].mat[0][1]	=	-(maty[2][i])*(matx[1][i]);
		temp[i].matrix[7].mat[1][0]	=	-(matx[2][i])*(maty[1][i]);
		temp[i].matrix[7].mat[1][1]	=	(matx[2][i])*(matx[1][i]);

		temp[i].matrix[8].mat[0][0]	=	(maty[2][i])*(maty[2][i]);
		temp[i].matrix[8].mat[0][1]	=	-(maty[2][i])*(matx[2][i]);
		temp[i].matrix[8].mat[1][0]	=	-(matx[2][i])*(maty[2][i]);
		temp[i].matrix[8].mat[1][1]	=	(matx[2][i])*(matx[2][i]);
	}

	for(i=0;i<tri_Num;i++)
	{
		geo->triangle[i].mat_lambda[0][0] = temp[i].matrix[0].mat[0][0];
		geo->triangle[i].mat_lambda[0][1] = temp[i].matrix[0].mat[0][1];
		geo->triangle[i].mat_lambda[0][2] = temp[i].matrix[1].mat[0][0];
		geo->triangle[i].mat_lambda[0][3] = temp[i].matrix[1].mat[0][1];
		geo->triangle[i].mat_lambda[0][4] = temp[i].matrix[2].mat[0][0];
		geo->triangle[i].mat_lambda[0][5] = temp[i].matrix[2].mat[0][1];

		geo->triangle[i].mat_lambda[1][0] = temp[i].matrix[0].mat[1][0];
		geo->triangle[i].mat_lambda[1][1] = temp[i].matrix[0].mat[1][1];
		geo->triangle[i].mat_lambda[1][2] = temp[i].matrix[1].mat[1][0];
		geo->triangle[i].mat_lambda[1][3] = temp[i].matrix[1].mat[1][1];
		geo->triangle[i].mat_lambda[1][4] = temp[i].matrix[2].mat[1][0];
		geo->triangle[i].mat_lambda[1][5] = temp[i].matrix[2].mat[1][1];

		geo->triangle[i].mat_lambda[2][0] = temp[i].matrix[3].mat[0][0];
		geo->triangle[i].mat_lambda[2][1] = temp[i].matrix[3].mat[0][1];
		geo->triangle[i].mat_lambda[2][2] = temp[i].matrix[4].mat[0][0];
		geo->triangle[i].mat_lambda[2][3] = temp[i].matrix[4].mat[0][1];
		geo->triangle[i].mat_lambda[2][4] = temp[i].matrix[5].mat[0][0];
		geo->triangle[i].mat_lambda[2][5] = temp[i].matrix[5].mat[0][1];

		geo->triangle[i].mat_lambda[3][0] = temp[i].matrix[3].mat[1][0];
		geo->triangle[i].mat_lambda[3][1] = temp[i].matrix[3].mat[1][1];
		geo->triangle[i].mat_lambda[3][2] = temp[i].matrix[4].mat[1][0];
		geo->triangle[i].mat_lambda[3][3] = temp[i].matrix[4].mat[1][1];
		geo->triangle[i].mat_lambda[3][4] = temp[i].matrix[5].mat[1][0];
		geo->triangle[i].mat_lambda[3][5] = temp[i].matrix[5].mat[1][1];

		geo->triangle[i].mat_lambda[4][0] = temp[i].matrix[6].mat[0][0];
		geo->triangle[i].mat_lambda[4][1] = temp[i].matrix[6].mat[0][1];
		geo->triangle[i].mat_lambda[4][2] = temp[i].matrix[7].mat[0][0];
		geo->triangle[i].mat_lambda[4][3] = temp[i].matrix[7].mat[0][1];
		geo->triangle[i].mat_lambda[4][4] = temp[i].matrix[8].mat[0][0];
		geo->triangle[i].mat_lambda[4][5] = temp[i].matrix[8].mat[0][1];

		geo->triangle[i].mat_lambda[5][0] = temp[i].matrix[6].mat[1][0];
		geo->triangle[i].mat_lambda[5][1] = temp[i].matrix[6].mat[1][1];
		geo->triangle[i].mat_lambda[5][2] = temp[i].matrix[7].mat[1][0];
		geo->triangle[i].mat_lambda[5][3] = temp[i].matrix[7].mat[1][1];
		geo->triangle[i].mat_lambda[5][4] = temp[i].matrix[8].mat[1][0];
		geo->triangle[i].mat_lambda[5][5] = temp[i].matrix[8].mat[1][1];

		geo->triangle[i].mat_mu[0][0] = 2*temp[i].matrix[0].mat[0][0]+temp[i].matrix[0].mat[1][1];
		geo->triangle[i].mat_mu[0][1] =		 						 +temp[i].matrix[0].mat[1][0];
		geo->triangle[i].mat_mu[0][2] = 2*temp[i].matrix[1].mat[0][0]+temp[i].matrix[1].mat[1][1];
		geo->triangle[i].mat_mu[0][3] =								 +temp[i].matrix[1].mat[1][0];
		geo->triangle[i].mat_mu[0][4] = 2*temp[i].matrix[2].mat[0][0]+temp[i].matrix[2].mat[1][1];
		geo->triangle[i].mat_mu[0][5] =								 +temp[i].matrix[2].mat[1][0];

		geo->triangle[i].mat_mu[1][0] =								 +temp[i].matrix[0].mat[0][1];
		geo->triangle[i].mat_mu[1][1] = 2*temp[i].matrix[0].mat[1][1]+temp[i].matrix[0].mat[0][0];
		geo->triangle[i].mat_mu[1][2] =								 +temp[i].matrix[1].mat[0][1];
		geo->triangle[i].mat_mu[1][3] = 2*temp[i].matrix[1].mat[1][1]+temp[i].matrix[1].mat[0][0];
		geo->triangle[i].mat_mu[1][4] =								 +temp[i].matrix[2].mat[0][1];
		geo->triangle[i].mat_mu[1][5] = 2*temp[i].matrix[2].mat[1][1]+temp[i].matrix[2].mat[0][0];

		geo->triangle[i].mat_mu[2][0] = 2*temp[i].matrix[3].mat[0][0]+temp[i].matrix[3].mat[1][1];
		geo->triangle[i].mat_mu[2][1] =								 +temp[i].matrix[3].mat[1][0];
		geo->triangle[i].mat_mu[2][2] = 2*temp[i].matrix[4].mat[0][0]+temp[i].matrix[4].mat[1][1];
		geo->triangle[i].mat_mu[2][3] =								 +temp[i].matrix[4].mat[1][0];
		geo->triangle[i].mat_mu[2][4] = 2*temp[i].matrix[5].mat[0][0]+temp[i].matrix[5].mat[1][1];
		geo->triangle[i].mat_mu[2][5] =								 +temp[i].matrix[5].mat[1][0];

		geo->triangle[i].mat_mu[3][0] =								 +temp[i].matrix[3].mat[0][1];
		geo->triangle[i].mat_mu[3][1] = 2*temp[i].matrix[3].mat[1][1]+temp[i].matrix[3].mat[0][0];
		geo->triangle[i].mat_mu[3][2] =								 +temp[i].matrix[4].mat[0][1];
		geo->triangle[i].mat_mu[3][3] = 2*temp[i].matrix[4].mat[1][1]+temp[i].matrix[4].mat[0][0];
		geo->triangle[i].mat_mu[3][4] =								 +temp[i].matrix[5].mat[0][1];
		geo->triangle[i].mat_mu[3][5] = 2*temp[i].matrix[5].mat[1][1]+temp[i].matrix[5].mat[0][0];

		geo->triangle[i].mat_mu[4][0] = 2*temp[i].matrix[6].mat[0][0]+temp[i].matrix[6].mat[1][1];
		geo->triangle[i].mat_mu[4][1] =								 +temp[i].matrix[6].mat[1][0];
		geo->triangle[i].mat_mu[4][2] = 2*temp[i].matrix[7].mat[0][0]+temp[i].matrix[7].mat[1][1];
		geo->triangle[i].mat_mu[4][3] =								 +temp[i].matrix[7].mat[1][0];
		geo->triangle[i].mat_mu[4][4] = 2*temp[i].matrix[8].mat[0][0]+temp[i].matrix[8].mat[1][1];
		geo->triangle[i].mat_mu[4][5] =								 +temp[i].matrix[8].mat[1][0];

		geo->triangle[i].mat_mu[5][0] =								 +temp[i].matrix[6].mat[0][1];
		geo->triangle[i].mat_mu[5][1] = 2*temp[i].matrix[6].mat[1][1]+temp[i].matrix[6].mat[0][0];
		geo->triangle[i].mat_mu[5][2] =								 +temp[i].matrix[7].mat[0][1];
		geo->triangle[i].mat_mu[5][3] = 2*temp[i].matrix[7].mat[1][1]+temp[i].matrix[7].mat[0][0];
		geo->triangle[i].mat_mu[5][4] =								 +temp[i].matrix[8].mat[0][1];
		geo->triangle[i].mat_mu[5][5] = 2*temp[i].matrix[8].mat[1][1]+temp[i].matrix[8].mat[0][0];
	}
	for(i=0;i<tri_Num;i++)
	{
		for(j=0;j<6;j++)
		{
			for(k=0;k<6;k++)
			{
				geo->triangle[i].mat_lambda[j][k]	= (h/(4*geo->triangle[i].area))*geo->triangle[i].mat_lambda[j][k];
				geo->triangle[i].mat_mu[j][k]		= (h/(4*geo->triangle[i].area))*geo->triangle[i].mat_mu[j][k];
			}
		}
	}
	//mFp
#if 0
	for(i=0;i<6;i++)
	{
		for(j=0;j<6;j++)
		{
			fprintf(fg,"%lf\t",geo->triangle[0].mat_lambda[i][j]);
		}
		fprintf(fg,"\n");
	}
	for(i=0;i<6;i++)
	{
		for(j=0;j<6;j++)
		{
			fprintf(fg,"%lf\t",geo->triangle[0].mat_mu[i][j]);
		}
		fprintf(fg,"\n");
	}
#endif
	//mFp܂
	//܂
	
	//eOp`vf̃[̒萔
	for(i=0;i<tri_Num;i++)
	{
		geo->triangle[i].Lela	= Lela;
		geo->triangle[i].Mela	= Mela;
		geo->triangle[i].Lvis	= Lvis;
		geo->triangle[i].Mvis	= Mvis;
		geo->triangle[i].Lvis2	= Ltvis;
		geo->triangle[i].Mvis2	= Mtvis;
	}
	//܂
}

