#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <windows.h>
#include <time.h>
#include "RK.h"
#include "data.h"
#include "func.h"
#include "structdata.h"

void compValue(double x[],double value[],double t,struct geo_data geo, struct sys_data *sys)
{
	int q;
	
	//-----------------CSM----------------------
	for(q=0;q<node_Num;q++)	
	{
		//ʍSp(xCyƂɌŒ)
		sys->CSMX[q] = 2*omega*sys->nsx[q]+(omega*omega)*sys->npx[q];	//2**Vn+^2*Un
		sys->CSMY[q] = 2*omega*sys->nsy[q]+(omega*omega)*sys->npy[q];
	}
	//-------------------------------------------

	//S͌vZ(ӂ̂)---------------------------
	for(q=0;q<wide+1;q++)
	{
		sys->LMX[q] = sys->FX[q]-(1.0/geo.MX[q])*sys->CSMX[q];
		sys->LMY[q] = sys->FY[q]-(1.0/geo.MY[q])*sys->CSMY[q];
	}
	for(q=0;q<wide+1;q++)
	{
		value[2*q+(8*node_Num)]		= sys->LMX[q];
		value[2*q+(8*node_Num+1)]	= sys->LMY[q];
	}
	//-----------------------------------------------

	//------d/dt(u)=	m[h̑x----------
	for(q=0;q<node_Num*2;q++)
	{
		value[q] = x[q+(2*node_Num)];
	}
	//----------------------------------------

	//d/dt(v)=	m[h̉x----------------
	for(q=0;q<node_Num;q++)
	{
		value[(q*2)+2*node_Num]		= (1.0/geo.MX[q])*(-sys->FX[q]);
		value[(q*2+1)+2*node_Num]	= (1.0/geo.MY[q])*(-sys->FY[q]);
	}
	//----------------------------------------

	//-----ʂSɌŒ(x,yɓȂ)Ăꍇ-----
	for(q=0;q<=wide;q++)
	{
		value[(q*2)+2*node_Num]		= -sys->CSMX[q];	//xŒ(Œ肵Ȃꍇ̓RgAEgĂ)
		value[(q*2+1)+2*node_Num]	= -sys->CSMY[q];	//yŒ
	}
	//-------------------------------------------------------------
}
