#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <windows.h>
#include <time.h>
#include "RK.h"
#include "data.h"
#include "func.h"
#include "structdata.h"

void make_GeoData_symmetry_type1(FILE *fg, FILE *ft, struct geo_data *geo)
{
	int i,j,k;
	//iq_̍W
//	fprintf(fg,"node data(x,y)\n");
	int point_num[4];
	for(j=0;j<=height;j++)
	{
		for(i=0;i<=wide;i++)
		{
			k = pointNumber(i,j,wide,height);
			geo->point[k].x = tri_wide*i;
			geo->point[k].y = tri_height*j;
			fprintf(fg,"%d\t",k);
			fprintf(fg,"%lf\t",geo->point[k].x);
			fprintf(fg,"%lf\t",geo->point[k].y);
			fprintf(fg,"\n");
		}
	}
	//܂
//-----------------------------------------------------//
	//Op`vf񐶐
	int pt[2][3];
	for(j=0;j<height;j++)
	{
		for(i=0;i<wide;i++)
		{
			point_num[0]	=	pointNumber(i	,j	,wide,height);
			point_num[1]	=	pointNumber(i+1	,j	,wide,height);
			point_num[2]	=	pointNumber(i	,j+1,wide,height);
			point_num[3]	=	pointNumber(i+1	,j+1,wide,height);

			if(!(j%2))
			{
				if(!(i%2))
				{
					pt[0][0] = 0; pt[0][1] = 1; pt[0][2] = 2;//Op`1
					pt[1][0] = 1; pt[1][1] = 3; pt[1][2] = 2;//Op`2
				}
				else
				{
					pt[0][0] = 0; pt[0][1] = 1; pt[0][2] = 3;//Op`1
					pt[1][0] = 0; pt[1][1] = 3; pt[1][2] = 2;//Op`2
				}
			}
			else
			{
				if(!(i%2))
				{
					pt[0][0] = 0; pt[0][1] = 1; pt[0][2] = 3;//Op`1
					pt[1][0] = 0; pt[1][1] = 3; pt[1][2] = 2;//Op`2
				}
				else
				{
					pt[0][0] = 0; pt[0][1] = 1; pt[0][2] = 2;//Op`1
					pt[1][0] = 1; pt[1][1] = 3; pt[1][2] = 2;//Op`2
				}
			}

			geo->triangle[2*i+(2*wide)*j].point_i = point_num[pt[0][0]];
			geo->triangle[2*i+(2*wide)*j].point_j = point_num[pt[0][1]];
			geo->triangle[2*i+(2*wide)*j].point_k = point_num[pt[0][2]];

			geo->triangle[2*i+1+(2*wide)*j].point_i = point_num[pt[1][0]];
			geo->triangle[2*i+1+(2*wide)*j].point_j = point_num[pt[1][1]];
			geo->triangle[2*i+1+(2*wide)*j].point_k = point_num[pt[1][2]];

			fprintf(ft,"%d\t",2*i+(2*wide)*j);
			fprintf(ft,"%d\t",geo->triangle[2*i+(2*wide)*j].point_i);
			fprintf(ft,"%d\t",geo->triangle[2*i+(2*wide)*j].point_j);
			fprintf(ft,"%d\t",geo->triangle[2*i+(2*wide)*j].point_k);
			fprintf(ft,"\n");

			fprintf(ft,"%d\t",2*i+1+(2*wide)*j);
			fprintf(ft,"%d\t",geo->triangle[2*i+1+(2*wide)*j].point_i);
			fprintf(ft,"%d\t",geo->triangle[2*i+1+(2*wide)*j].point_j);
			fprintf(ft,"%d\t",geo->triangle[2*i+1+(2*wide)*j].point_k);
			fprintf(ft,"\n");
		}
	}
}