#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <windows.h>
#include <time.h>
#include "RK.h"
#include "data.h"
#include "func.h"
#include "geodata.h"
#include "structdata.h"

void make_InertiaMat(struct geo_data *geo)
{
	int i,ti,tj,tk;
/*	
	for(i=0;i<node_Num;i++)
	{
		geo->MX[i] = 0.0;
		geo->MY[i] = 0.0;
	}
*/
	for(i=0;i<tri_Num;i++)
	{
		ti = geo->triangle[i].point_i;
		tj = geo->triangle[i].point_j;
		tk = geo->triangle[i].point_k;

		geo->MX[ti]	+= (D*h*geo->triangle[i].area)/3.0;
		geo->MY[ti]	+= (D*h*geo->triangle[i].area)/3.0;
		geo->MX[tj]	+= (D*h*geo->triangle[i].area)/3.0;
		geo->MY[tj]	+= (D*h*geo->triangle[i].area)/3.0;
		geo->MX[tk]	+= (D*h*geo->triangle[i].area)/3.0;
		geo->MY[tk]	+= (D*h*geo->triangle[i].area)/3.0;
	}
}